

/**This class serves as the Global Name Server(GNS). It also sends out message requesting
  *the PEs to compute their local min time, based on which it will compute the GVT.
  *
  *@version 1.9 (09/2006)
  *@author Yin Xiong
  */
public class Controller implements Runnable{

/** all the PEs in this simulation */

int sleepTime=500;
Flag eosFlag=new Flag();
boolean endOfSim=false;
Flag gvtFlag=new Flag();
boolean timeForGvt=false;
PE[] PEs; 
int newGVT; 


/**
  * Constructer.
  */
 public Controller(PE[] pes, Flag ef, Flag gf)
{
   PEs=pes;
   eosFlag=ef;
   gvtFlag=gf;
}//end constructor

  /**
  * Implements TimerTask's abstract run method.
  */
  public void run(){

  try{
    while(!endOfSim){
     if(gvtFlag.get()>0){
        System.out.println("\nIt's time to compute GVT...");
        newGVT=computeGVT();     
        System.out.println("new GVT: " + newGVT);

       //broadcast the new GVT
       for(int i=0;i<PEs.length;i++){
         PEs[i].schedulingLoop.updateGVT(newGVT);

       //reset gvt flag
       gvtFlag.set(0);
    }//end for
   }//end if

   if(eosFlag.get()<0)
    endOfSim=true;
         
    Thread thisThread=Thread.currentThread();
    thisThread.sleep(sleepTime);


   }//end while
  }//end try

  catch(Exception e){
    e.printStackTrace();
  }

  }//end run


/**Compute GVT/
  */
int computeGVT()
{
  int newGVT=100000;
  int lvt;
  for(int i=0;i<PEs.length;i++){
    lvt=PEs[i].schedulingLoop.computeLocalMin();
    if(lvt<newGVT){
       newGVT=lvt;
     }//end if
  }//end for

return newGVT;

}//end computeGVT

}//end class
 
