import java.io.*;
import java.util.*;
import java.lang.*;


/** This class represents a message pool that store all the messages sent among PEs.
  * @author Yin Xiong
  * @version 1.1 (02/2006)
  */
  
 
public class MessagePool{

Vector<Message> messages=new Vector<Message>();

public synchronized Message getMsgFromPool(int peid, int lpid)
{
   Message msg=null;
   for(int i=0;i<messages.size();i++){
      msg=(Message)messages.get(i);
	  if(msg.getReceiverPE()==peid && msg.getReceiverLP()==lpid){
	    //System.out.println("msgPool,get msg content: " + msg.getContent());
	    messages.remove(i);
	    return msg;
	   }
   }
   
   return null;
	  
}
public synchronized int addMsgToPool(Message msg)
{
    messages.add(msg);
	return messages.size();
}
public int size()
{
   return messages.size();
}

public synchronized Vector getMsgsForMe(int pid)
{
  Vector<Message> msgs=new Vector<Message>();
  for(int i=0;i<messages.size();i++){
     Message msg=(Message)messages.get(i);
	 if(msg.getReceiverPE()==pid){
	    msg=(Message)messages.remove(i);
	     msgs.add(msg);
	  }
   }//end for
   return msgs;
}//end getMsgsForMe
}//end class MessagePool
